Есть необходимость запустить сразу два демона sshd на разных портах - 22 и 2022.
Система Ubuntu 20.04.1 LTS SSH-2.0-OpenSSH_8.2p1
Нашел что то похожее в интернете, только там на Fedora делают
https://sys-adm.in/os/nix/801-ssh-na-neskolkikh-portakh-neskolko-servisov-ssh...
Скопировал файл sshd с другим именем (sshd_2) , в ту же директорию, где и изначальный sshd находится - /usr/sbin/sshd_2
Скопировал текущий конфиг для 22 порта, поменял порт на 2022:
/etc/ssh/sshd_config_2
Port 2022
#ListenAddress ::
#ListenAddress 0.0.0.0
Protocol 2
HostKey /etc/ssh/ssh_host_rsa_key
HostKey /etc/ssh/ssh_host_dsa_key
HostKey /etc/ssh/ssh_host_ecdsa_key
HostKey /etc/ssh/ssh_host_ed25519_key
SyslogFacility AUTH
LogLevel INFO
LoginGraceTime 120
PermitRootLogin prohibit-password
StrictModes yes
PubkeyAuthentication yes
#AuthorizedKeysFile %h/.ssh/authorized_keys
IgnoreRhosts yes
HostbasedAuthentication no
#IgnoreUserKnownHosts yes
PermitEmptyPasswords no
ChallengeResponseAuthentication no
PasswordAuthentication no
X11Forwarding yes
X11DisplayOffset 10
PrintMotd yes
PrintLastLog yes
TCPKeepAlive yes
#UseLogin no
#MaxStartups 10:30:60
#Banner /etc/issue.net
AcceptEnv LANG LC_*
Subsystem sftp /usr/lib/openssh/sftp-server
UsePAM yes
ClientAliveInterval 60
UseDNS no
Запускаю sshd c указанием конфиг файла: /usr/sbin/sshd_2 -f /etc/ssh/sshd_config_2
Все нормально запускается, без вопросов ss -tulpn | grep sshd
tcp LISTEN 0 128 0.0.0.0:22 0.0.0.0:* users:(("sshd",pid=1088,fd=3))
tcp LISTEN 0 128 0.0.0.0:2022 0.0.0.0:* users:(("sshd_2",pid=30731,fd=3))
tcp LISTEN 0 128 [::]:22 [::]:* users:(("sshd",pid=1088,fd=4))
tcp LISTEN 0 128 [::]:2022 [::]:* users:(("sshd_2",pid=30731,fd=4))
Скопировал файл запуска демона с новым именем ssh_2. Вроде бы везде где нужно заменил sshd на sshd_2 . Еще добавил передачу параметра с конфиг файлом SSHD_2_OPTS="-f /etc/ssh/sshd_config_2" . Как его по другому заставить читать файл с конфигом, не придумал.
/etc/init.d/ssh_2
#! /bin/sh
### BEGIN INIT INFO
# Provides: sshd_2
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop:
# Short-Description: OpenBSD Secure Shell server
### END INIT INFO
set -e
# /etc/init.d/ssh: start and stop the OpenBSD "secure shell(tm)" daemon
test -x /usr/sbin/sshd_2 || exit 0
( /usr/sbin/sshd_2 -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0
umask 022
if test -f /etc/default/ssh_2; then
. /etc/default/ssh_2
fi
. /lib/lsb/init-functions
if [ -n "$2" ]; then
SSHD_2_OPTS="$SSHD_2_OPTS $2"
fi
SSHD_2_OPTS="-f /etc/ssh/sshd_config_2"
# Are we running from init?
run_by_init() {
([ "$previous" ] && [ "$runlevel" ]) || [ "$runlevel" = S ]
}
check_for_no_start() {
# forget it if we're trying to start, and /etc/ssh/sshd_2_not_to_be_run exists
if [ -e /etc/ssh/sshd_2_not_to_be_run ]; then
if [ "$1" = log_end_msg ]; then
log_end_msg 0 || true
fi
if ! run_by_init; then
log_action_msg "OpenBSD Secure Shell server not in use (/etc/ssh/sshd_2_not_to_be_run)" || true
fi
exit 0
fi
}
check_dev_null() {
if [ ! -c /dev/null ]; then
if [ "$1" = log_end_msg ]; then
log_end_msg 1 || true
fi
if ! run_by_init; then
log_action_msg "/dev/null is not a character device!" || true
fi
exit 1
fi
}
check_privsep_dir() {
# Create the PrivSep empty dir if necessary
if [ ! -d /run/sshd_2 ]; then
mkdir /run/sshd_2
chmod 0755 /run/sshd_2
fi
}
check_config() {
if [ ! -e /etc/ssh/sshd_2_not_to_be_run ]; then
/usr/sbin/sshd_2 $SSHD_2_OPTS -t || exit 1
fi
}
export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"
case "$1" in
start)
check_privsep_dir
check_for_no_start
check_dev_null
log_daemon_msg "Starting OpenBSD Secure Shell server" "sshd_2" || true
if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
log_end_msg 0 || true
else
log_end_msg 1 || true
fi
;;
stop)
log_daemon_msg "Stopping OpenBSD Secure Shell server" "sshd_2" || true
if start-stop-daemon --stop --quiet --oknodo --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2; then
log_end_msg 0 || true
else
log_end_msg 1 || true
fi
;;
reload|force-reload)
check_for_no_start
check_config
log_daemon_msg "Reloading OpenBSD Secure Shell server's configuration" "sshd_2" || true
if start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2; then
log_end_msg 0 || true
else
log_end_msg 1 || true
fi
;;
restart)
check_privsep_dir
check_config
log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd_2" || true
start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2
check_for_no_start log_end_msg
check_dev_null log_end_msg
if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
log_end_msg 0 || true
else
log_end_msg 1 || true
fi
;;
try-restart)
check_privsep_dir
check_config
log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd_2" || true
RET=0
start-stop-daemon --stop --quiet --retry 30 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 || RET="$?"
case $RET in
0)
# old daemon stopped
check_for_no_start log_end_msg
check_dev_null log_end_msg
if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
log_end_msg 0 || true
else
log_end_msg 1 || true
fi
;;
1)
# daemon not running
log_progress_msg "(not running)" || true
log_end_msg 0 || true
;;
*)
# failed to stop
log_progress_msg "(failed to stop)" || true
log_end_msg 1 || true
;;
esac
;;
status)
status_of_proc -p /run/sshd_2.pid /usr/sbin/sshd_2 sshd_2 && exit 0 || exit $?
;;
*)
log_action_msg "Usage: /etc/init.d/ssh {start|stop|reload|force-reload|restart|try-restart|status}" || true
exit 1
esac
exit 0
Скопировал файл параметров демона. По идее через этот файл надо было бы предавать параметр с конфиг файлом, но что то никак не получается, поэтому он такой же как оригинальный
/etc/default/ssh_2
# Default settings for openssh-server. This file is sourced by /bin/sh from
# /etc/init.d/ssh.
# Options to pass to sshd
SSHD_OPTS_2=
Пробую запустить демон /etc/init.d/ssh_2 start
стартует, все ок.
Пробую остановить, /etc/init.d/ssh_2 stop
Не останавливается. Висит по прежнему на том же порту 2022. Подключиться можно к обоим sshd.
ss -tulpn | grep sshd
tcp LISTEN 0 128 0.0.0.0:22 0.0.0.0:* users:(("sshd",pid=1088,fd=3))
tcp LISTEN 0 128 0.0.0.0:2022 0.0.0.0:* users:(("sshd_2",pid=30731,fd=3))
tcp LISTEN 0 128 [::]:22 [::]:* users:(("sshd",pid=1088,fd=4))
tcp LISTEN 0 128 [::]:2022 [::]:* users:(("sshd_2",pid=30731,fd=4))
Если же остановить основной сервис sshd, то подключиться к ssh_2 (2022 порт ) не получается ( ну и к 22 порту тоже, что вроде бы логично, я же его остановил)
/etc/init.d/ssh stop
ошибка : ssh san@localhost -p 2022
kex_exchange_identification: read: Connection reset by peer
Хотя порт 2022 открыт
ss -tulpn | grep sshd
tcp LISTEN 0 128 0.0.0.0:2022 0.0.0.0:* users:(("sshd_2",p
id=1590,fd=3))
tcp LISTEN 0 128 [::]:2022 [::]:* users:(("sshd_2",p
id=1590,fd=4))
В чем ошибка, почему не работают нормально два демона sshd ?